瀏覽代碼

Adding scripts

julien colomb 3 年之前
父節點
當前提交
767dc8fc77
共有 3 個文件被更改,包括 265 次插入0 次删除
  1. 58 0
      SSH-INIT-SYNC
  2. 108 0
      scripts/GIN-sync
  3. 99 0
      scripts/template_init.command

+ 58 - 0
SSH-INIT-SYNC

@@ -0,0 +1,58 @@
+#!/usr/bin/env bash
+#
+# Initialise or Upload changes from inside repository
+# using GIN CLI
+# Works with submodules and repo made by tonic v1 (not copying submodules content).
+# needs git config to be set 
+# needs SSH access to GIN
+# future dvt using datalad will allow use of non-GIN repositories
+
+# logic: template has a specific file to label it needs initialisation.
+# if this file is present, code 1 is done: template_initialisation
+# if it is absent but submodules are empty, code 2 is done: submodule_initialisation
+# if none of the above code 3 is done: synchronisation
+
+# Set folder where script will be executed 
+loc=$(dirname $0)
+projectdir=$(git -C ${loc} rev-parse --show-toplevel)
+
+pushd ${loc} > /dev/null
+
+## code 1
+if test -f "00repo_needs_initialisation00.txt" ;
+  then
+  echo "running project repository initiation (first run)"
+  sh scripts/template_init.command
+fi
+
+## code 2
+ 
+if  (test -f "03_data/001_data/README_data.md") ;
+  then
+  echo "submodules are initialised"
+  
+  else
+  echo "initialising submodules"
+  git submodule update --init --recursive
+  git submodule foreach gin init
+fi
+
+## code 3
+
+
+usage() {
+    echo "$0 <sync-option>"
+    echo
+    echo "<sync-option>     The sync option defines what to do with the content of large files."
+    echo "                  It should be one of the following values:"
+    echo "                     download - Download all large file content from the server"
+    echo "                     keep     - Keep all large file content but do not download missing large files"
+    echo "                     remove   - Do not download large files and remove existing local large file content"
+    exit 1
+}
+
+# Set the variable for synchronisation option, see above 
+syncopt="remove"
+
+echo "start synchronisation in "$syncopt" mode, close window to cancel. change mode by changing the code in a text application"
+sh scripts/GIN-SYNC

+ 108 - 0
scripts/GIN-sync

@@ -0,0 +1,108 @@
+#!/usr/bin/env bash
+#
+# Upload changes from inside repository using GIN CLI
+# Works with submodules.
+# needs git config to be set and user should be logged in
+# needs submodules and main repo to be initialised (gin init)
+
+
+
+
+
+
+
+# Checking synchronisation option and giving feedback
+checkargs() {
+    case "$1" in
+        download)
+            echo "Downloading and keep all large file content"
+            ;;
+        keep)
+            echo "Keeping existing local large file content, do not downlad extra files"
+            ;;
+        remove)
+            echo "Removing all local large file content"
+            ;;
+        *)
+            usage
+            ;;
+    esac
+}
+
+checkargs "${syncopt}"
+
+checkerror() {
+    err=$1
+    msg=$2
+    if [[ ${err} != 0 ]]; then
+        echo "${msg}" >> ./.log/gin.log
+	echo "${err}" >> ./.log/gin.log
+        echo "${msg}"
+        echo "Press [Enter] to close this window"
+        read -r
+        exit 1
+    fi
+}
+
+# Set commit message
+echo "Optionally enter a commit message, and hit return: "  
+read commitmessage 
+
+if [[ "$commitmessage" == "" ]]; then
+        echo "using date as commit message"
+	commitmessage="commit on $(date +%Y-%m-%d)"    
+fi
+
+
+# write log
+mkdir -p ./.log
+echo "$(date +'%Y-%m-%dT%H:%M:%S'): Sync script executed" >> ./.log/gin.log
+
+# create empty .gitmodules if it does not exist
+FILE=.gitmodules
+if [ -f "$FILE" ]; then
+    echo "$FILE already exists."
+else 
+    touch "$FILE"
+fi
+
+echo "intialise submodules"
+git submodule foreach gin init
+
+echo "Synchronising submodules"
+git submodule foreach gin commit . -m "$commitmessage"
+checkerror $? "Error occurred during 'gin commit'"
+git submodule foreach gin sync
+checkerror $? "Error occurred during 'gin sync'"
+
+git submodule foreach gin upload
+checkerror $? "Error occurred during 'gin upload'"
+
+## remove uploaded (annexed) content
+if [[ "$syncopt" == "remove" ]]; then
+        git submodule foreach gin remove-content 
+        checkerror $? "Error occurred during 'gin remove-content'"
+    fi
+# get annexed content 
+if [[ "${syncopt}" == "download" ]]; then
+        git submodule foreach gin get-content .
+        checkerror $? "Error occurred during 'gin get-content .'"
+    fi    
+
+
+echo "Synchronising main repository"
+
+gin commit . -m "$commitmessage"
+gin sync
+gin upload
+
+# remove uploaded (annexed) content
+if [[ "$syncopt" == "remove" ]]; then
+        gin remove-content 
+        checkerror $? "Error occurred during 'gin remove-content' in main repo"
+    fi
+# get annexed content 
+if [[ "${syncopt}" == "download" ]]; then
+        gin get-content .
+        checkerror $? "Error occurred during 'gin get-content . in main repo'"
+    fi   

+ 99 - 0
scripts/template_init.command

@@ -0,0 +1,99 @@
+#!/usr/bin/env bash
+#
+# update template submodules manually
+# run once in the main folder after the template has been made by tonic
+
+
+
+# Set folder where script will be executed
+#loc=$(dirname $0)
+#projectdir=$(git -C ${loc} rev-parse --show-toplevel)
+#
+#pushd ${loc} > /dev/null
+
+# get info for gin remote information
+# go on main branch
+git checkout main
+
+GINinfo="$(gin remotes)"
+Gitadress="$(echo $GINinfo | cut -d'/' -f3)"
+
+Orga="$(echo $GINinfo | cut -d'/' -f4)"
+repo2="$(echo $GINinfo | cut -d'/' -f5)"
+repo="$(echo $repo2 | cut -d' ' -f1)"
+reposhort="$(echo "${repo/.main}")"
+
+
+# readme text
+readmetext="$Gitadress/$Orga/$repo is the parent directory"
+
+echo "readme will be $readmetext"
+
+# initialise submodules
+git submodule update --init --recursive
+
+# if the template was not initialise before, let's do it
+if test -f "03_data/001_data/README_data.md" ;
+then
+    echo "submodules in place, happy working!"
+else
+    echo "setting up the template for the first time !"
+    
+    # add readme files, and folders
+    echo "$readmetext" >> 03_data/001_data/README_data.md
+    echo "$readmetext" >> 04_data_analysis/010_code/README_analysiscode.md
+    echo "$readmetext" >> 05_figures/990_shared_figures/README_figures.md
+    echo "$readmetext" >> 03_data/001_data/README_data.md
+    echo "$readmetext" >> 06_dissemination/README_DISSEMINATION.md
+    mkdir 06_dissemination/01_reports_conferences
+    mkdir 06_dissemination/02_manuscripts
+    mkdir 06_dissemination/03_other
+    touch 06_dissemination/01_reports_conferences/.gitkeep
+    touch 06_dissemination/02_manuscripts/.gitkeep
+    touch 06_dissemination/03_other/.gitkeep
+    
+    # add labcommons submodule
+    git submodule add "ssh://$Gitadress/$Orga/"labcommons"" testlabcommons
+    
+    # push submodule content
+    git submodule foreach gin init
+    git submodule foreach gin commit . -m initial commit from template
+    git submodule foreach gin upload
+    
+    # delete file telling the initialisation need to be done
+    rm "00repo_needs_initialisation00.txt"
+
+    # arrange parent repository
+    gin commit .
+    
+    git checkout --orphan newbranch
+    git add -A
+    git commit -m "created from template"
+    git branch -D main
+    git branch -m master
+    git push -f origin master
+    
+    # add submodule to PI repo
+    # get labreports repo and write new folder for the project
+    cd ../
+    gin get ""$Orga""/labreports""
+    cd labreports
+    mkdir "$reposhort"
+    mkdir "$reposhort/05_figures"
+    
+    
+    # add 2 submodule for figures and dissemination files there
+    
+    git submodule add "../$reposhort.05_figures_990_shared_figures.git" ""$reposhort"/05_figures/990_shared_figures"
+    git submodule add "../$reposhort.06_dissemination" ""$reposhort"/06_dissemination"
+    
+    # add a file to tell the user/script to initialise the submodules next time.
+    
+    echo "submodules need intitialisation due to project $repo " >> "initialise.txt"
+    
+    # push changes on the server and remove the repo from the computer.
+    gin commit . -m "added project $reposhort"
+    gin upload
+    cd ../
+    rm -rf labreports
+fi